//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 05: OpenMp
//
//  Description: Sort using openMP. Serial Pair Sort
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************

Compiling:   gcc-9 accFillEx1.c -o accFillEx1 -O3 -fopenacc -foffload=nvptx-none  -fopt-info
Executing:    ./accFillEx1

Output in my Laptop
Total number of errors is 0

real	0m0.039s
user	0m0.014s
sys	0m0.025s

*/

#include <stdio.h>

#define N 10000000
int A[N] ;

// ***************************************************************
int main(int argc, char *argv[])
{

#pragma acc parallel loop copyout( A[0:N] )
   for(int i=0; i < N; i++)
     A[i] = i;

   int sum=0;
   for(int i=0; i < N; i++)
     if ( A[i] != i ) sum++ ;

   printf( "Total number of errors is %d\n", sum);

   return 0; // normal exit
}
